diff --git a/changelog b/changelog
index a90755b..4fb1bcc 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,6 @@
+20140907 tpd src/axiom-website/patches.html 20140907.01.tpd.patch
+20140907 tpd src/input/Makefile add groeb.input
+20140907 tpd src/input/groeb.input test case for groebner basis
 20140906 tpd src/axiom-website/patches.html 20140906.01.tpd.patch
 20140906 tpd books/bookvol10.3 add SparseEchelonMatrix domain
 20140906 tpd books/bookvol10 add SparseEchelonMatrix domain
diff --git a/patch b/patch
index f45c72c..09aaa08 100644
--- a/patch
+++ b/patch
@@ -1,3 +1,3 @@
-books/bookvol10.3 add SparseEchelonMatrix domain
+src/input/groeb.input test case for groebner basis
 
-Add the SparseEchelonMatrix (SEM)
+write some tests for the groebner basis code
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 3ea8770..bb24bb7 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -4630,6 +4630,8 @@ src/axiom-website/videos.html add Building Test Cases video<br/>
 books/bookvol10.4 add graphviz package<br/>
 <a href="patches/20140906.01.tpd.patch">20140906.01.tpd.patch</a>
 books/bookvol10.3 add SparseEchelonMatrix domain<br/>
+<a href="patches/20140907.01.tpd.patch">20140907.01.tpd.patch</a>
+src/input/groeb.input test case for groebner basis<br/>
  </body>
 </html>
 
diff --git a/src/input/Makefile.pamphlet b/src/input/Makefile.pamphlet
index 5f7e4e1..94ddfec 100644
--- a/src/input/Makefile.pamphlet
+++ b/src/input/Makefile.pamphlet
@@ -344,7 +344,7 @@ REGRESSTESTS= ackermann.regress \
     function.regress  functioncode.regress \
     galois.regress    gamma.regress \
     gbf.regress       genups.regress   gonshor.regress  graphviz.regress \
-    grpthry.regress \
+    groeb.regress     grpthry.regress \
     gstbl.regress     guess.regress \
     heap.regress      heat.regress     help.regress \
     herm.regress      heugcd.regress \
@@ -955,8 +955,8 @@ FILES2=${OUT}/arith.input    ${OUT}/bugs.input \
        ${OUT}/exsum.input    ${OUT}/fns.input        \
        ${OUT}/function.input ${OUT}/free.input       \
        ${OUT}/galois.input   ${OUT}/gamma.input \
-       ${OUT}/grpthry.input \
-       ${OUT}/help.input       ${OUT}/intef2.input \
+       ${OUT}/groeb.input    ${OUT}/grpthry.input \
+       ${OUT}/help.input     ${OUT}/intef2.input \
        ${OUT}/intmix2.input  ${OUT}/knot2.input      ${OUT}/linalg.input \
        ${OUT}/loop.input \
        ${OUT}/numbers.input \
@@ -1182,7 +1182,8 @@ DOCFILES= \
   ${DOC}/genups.input.dvi      ${DOC}/gnarly1.input.dvi    \
   ${DOC}/gonshor.input.dvi     ${DOC}/graphics.input.dvi   \
   ${DOC}/graphviz.input.dvi    \
-  ${DOC}/grdef.input.dvi       ${DOC}/grpthry.input.dvi    \
+  ${DOC}/grdef.input.dvi       ${DOC}/groeb.input.dvi      \
+  ${DOC}/grpthry.input.dvi    \
   ${DOC}/gstbl.input.dvi       ${DOC}/guess.input.dvi      \
   ${DOC}/heap.input.dvi       \
   ${DOC}/heat.input.dvi        ${DOC}/helix.input.dvi      \
diff --git a/src/input/groeb.input.pamphlet b/src/input/groeb.input.pamphlet
new file mode 100644
index 0000000..4ba10f6
--- /dev/null
+++ b/src/input/groeb.input.pamphlet
@@ -0,0 +1,525 @@
+\documentclass{article}
+\usepackage{axiom}
+\setlength{\textwidth}{400pt}
+\begin{document}
+\title{\$SPAD/src/input groeb.input}
+\author{Timothy Daly}
+\maketitle
+\begin{abstract}
+\end{abstract}
+\eject
+\tableofcontents
+\eject
+\begin{chunk}{*}
+)set break resume
+)sys rm -f groeb.output
+)spool groeb.output
+)set message test on
+)set message auto off
+)clear all
+
+--S 1 of 12
+s1:DMP([w,p,z,t,s,b],FRAC(INT)):= 45*p + 35*s - 165*b - 36 
+--R 
+--R
+--R   (1)  45p + 35s - 165b - 36
+--R     Type: DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer))
+--E 1
+
+--S 2 of 12
+s2:DMP([w,p,z,t,s,b],FRAC(INT)):= 35*p + 40*z + 25*t - 27*s 
+--R 
+--R
+--R   (2)  35p + 40z + 25t - 27s
+--R     Type: DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer))
+--E 2
+
+--S 3 of 12
+s3:DMP([w,p,z,t,s,b],FRAC(INT)):= 15*w + 25*p*s + 30*z - 18*t - 165*b**2 
+--R 
+--R
+--R                                      2
+--R   (3)  15w + 25p s + 30z - 18t - 165b
+--R     Type: DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer))
+--E 3
+
+--S 4 of 12
+s4:DMP([w,p,z,t,s,b],FRAC(INT)):= -9*w + 15*p*t + 20*z*s 
+--R 
+--R
+--R   (4)  - 9w + 15p t + 20z s
+--R     Type: DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer))
+--E 4
+
+--S 5 of 12
+s5:DMP([w,p,z,t,s,b],FRAC(INT)):= w*p + 2*z*t - 11*b**3 
+--R 
+--R
+--R                        3
+--R   (5)  w p + 2z t - 11b
+--R     Type: DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer))
+--E 5
+
+--S 6 of 12
+s6:DMP([w,p,z,t,s,b],FRAC(INT)):= 99*w - 11*b*s + 3*b**2 
+--R 
+--R
+--R                        2
+--R   (6)  99w - 11s b + 3b
+--R     Type: DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer))
+--E 6
+
+--S 7 of 12
+s7:DMP([w,p,z,t,s,b],FRAC(INT)):= b**2 + 33/50*b + 2673/10000 
+--R 
+--R
+--R         2   33      2673
+--R   (7)  b  + -- b + -----
+--R             50     10000
+--R     Type: DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer))
+--E 7
+
+--S 8 of 12
+sn7:=[s1,s2,s3,s4,s5,s6,s7] 
+--R 
+--R
+--R   (8)
+--R   [45p + 35s - 165b - 36, 35p + 40z + 25t - 27s,
+--R                                  2                                        3
+--R    15w + 25p s + 30z - 18t - 165b , - 9w + 15p t + 20z s, w p + 2z t - 11b ,
+--R                    2   2   33      2673
+--R    99w - 11s b + 3b , b  + -- b + -----]
+--R                            50     10000
+--RType: List(DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer)))
+--E 8
+
+--S 9 of 12
+groebner(sn7,"info","redcrit")
+--R 
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R       5     61     77      7
+--R   z + - t - -- s + -- b + --
+--R       8     45     24     10
+--R
+--R
+--R
+--R   you choose option  -info-
+--R   abbrev. for the following information strings are
+--R     ci  =>  Leading monomial  for critpair calculation
+--R     tci =>  Number of terms of polynomial i
+--R     cj  =>  Leading monomial  for critpair calculation
+--R     tcj =>  Number of terms of polynomial j
+--R     c   =>  Leading monomial of critpair polynomial
+--R     tc  =>  Number of terms of critpair polynomial
+--R     rc  =>  Leading monomial of redcritpair polynomial
+--R     trc =>  Number of terms of redcritpair polynomial
+--R     tF  =>  Number of polynomials in reduction list F
+--R     tD  =>  Number of critpairs still to do
+--R
+--R
+--R
+--R
+--R
+--R   [[ci= p,tci= 4,cj= p,tcj= 4,c= z,tc= 5,rc= z,trc= 5,tF= 4,tD= 3]]
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R         66        603     278  2   11       672     2277     415881
+--R   t s - -- t b + ---- t - --- s  + -- s b - --- s - ---- b - ------
+--R         29       1450     435      29       725     7250     725000
+--R
+--R
+--R
+--R   [[ci= w,tci= 3,cj= w,tcj= 5,c= p t,tc= 6,rc= t s,trc= 8,tF= 5,tD= 2]]
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R       100  2   160       104      37      79
+--R   t + --- s  - --- s b - --- s - --- b - ---
+--R       189       63        63     105     125
+--R
+--R
+--R
+--R   [[ci= w,tci= 3,cj= w,tcj= 3,c= p t,tc= 4,rc= t,trc= 6,tF= 5,tD= 2]]
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R    3   1026  2    5424  2   2529       1326807     12717      660717
+--R   s  - ---- s b - ---- s  - ---- s b - ------- s + ----- b + -------
+--R         145       3625       725        362500      6250     3625000
+--R
+--R
+--R
+--R                                                   3
+--R   [[ci= t s,tci= 8,cj= t,tcj= 6,c= t b,tc= 9,rc= s ,trc= 7,tF= 6,tD= 1]]
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R      2     91248294  2   6550614        7087292937     20020838931
+--R     s b + --------- s  - ------- s b + ----------- s - ----------- b
+--R           128176525      5127061       12817652500     12817652500
+--R   + 
+--R       37595502243
+--R     - -----------
+--R       51270610000
+--R
+--R
+--R
+--R                                                     2
+--R   [[ci= w p,tci= 3,cj= w,tcj= 3,c= p s b,tc= 4,rc= s b,trc= 6,tF= 7,tD= 2]]
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R      2   4746183626079988       1015195815329760     30723564870033201
+--R     s  - ---------------- s b - ---------------- s - ----------------- b
+--R           987357073521193        987357073521193     24683926838029825
+--R   + 
+--R       3696123458901625353
+--R     - -------------------
+--R       2468392683802982500
+--R
+--R
+--R
+--R          2             2             2             2
+--R   [[ci= b ,tci= 3,cj= s b,tcj= 6,c= s b,tc= 6,rc= s ,trc= 5,tF= 6,tD= 2]]
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R   0
+--R
+--R
+--R
+--R          2              2            2
+--R   [[ci= s b,tci= 6,cj= s ,tcj= 5,c= s ,tc= 7,rc= 0,trc= 0,tF= 6,tD= 1]]
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R           16827373608076633182513471     1262793163581645698534964
+--R     s b + -------------------------- s - ------------------------- b
+--R           23063714246644859914108300     5765928561661214978527075
+--R   + 
+--R      91594345205981119652436033
+--R     ---------------------------
+--R     144148214041530374463176875
+--R
+--R
+--R
+--R          3             2            2
+--R   [[ci= s ,tci= 7,cj= s ,tcj= 5,c= s b,tc= 6,rc= s b,trc= 4,tF= 7,tD= 2]]
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R       5      9
+--R   s - - b - ---
+--R       2     200
+--R
+--R
+--R
+--R          2
+--R   [[ci= b ,tci= 3,cj= s b,tcj= 4,c= s b,tc= 4,rc= s,trc= 3,tF= 6,tD= 2]]
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R   0
+--R
+--R
+--R
+--R   [[ci= s b,tci= 4,cj= s,tcj= 3,c= s,tc= 4,rc= 0,trc= 0,tF= 6,tD= 1]]
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R   0
+--R
+--R
+--R
+--R          2
+--R   [[ci= s ,tci= 5,cj= s,tcj= 3,c= s b,tc= 4,rc= 0,trc= 0,tF= 6,tD= 0]]
+--R
+--R
+--R     There are
+--R
+--R   6
+--R
+--R     Groebner Basis Polynomials.
+--R
+--R
+--R       THE GROEBNER BASIS POLYNOMIALS
+--R
+--R   (9)
+--R         19      1323      31     153      49     1143      37      27
+--R   [w + --- b + -----, p - -- b - ---, z + -- b + ----, t - -- b + ---,
+--R        120     20000      18     200      36     2000      15     250
+--R        5      9    2   33      2673
+--R    s - - b - ---, b  + -- b + -----]
+--R        2     200       50     10000
+--RType: List(DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer)))
+--E 9
+
+--S 10 of 12
+groebner(sn7,"info") 
+--R 
+--R
+--R   you choose option  -info-
+--R   abbrev. for the following information strings are
+--R     ci  =>  Leading monomial  for critpair calculation
+--R     tci =>  Number of terms of polynomial i
+--R     cj  =>  Leading monomial  for critpair calculation
+--R     tcj =>  Number of terms of polynomial j
+--R     c   =>  Leading monomial of critpair polynomial
+--R     tc  =>  Number of terms of critpair polynomial
+--R     rc  =>  Leading monomial of redcritpair polynomial
+--R     trc =>  Number of terms of redcritpair polynomial
+--R     tF  =>  Number of polynomials in reduction list F
+--R     tD  =>  Number of critpairs still to do
+--R
+--R
+--R
+--R
+--R
+--R   [[ci= p,tci= 4,cj= p,tcj= 4,c= z,tc= 5,rc= z,trc= 5,tF= 4,tD= 3]]
+--R
+--R
+--R   [[ci= w,tci= 3,cj= w,tcj= 5,c= p t,tc= 6,rc= t s,trc= 8,tF= 5,tD= 2]]
+--R
+--R
+--R   [[ci= w,tci= 3,cj= w,tcj= 3,c= p t,tc= 4,rc= t,trc= 6,tF= 5,tD= 2]]
+--R
+--R
+--R                                                   3
+--R   [[ci= t s,tci= 8,cj= t,tcj= 6,c= t b,tc= 9,rc= s ,trc= 7,tF= 6,tD= 1]]
+--R
+--R
+--R                                                     2
+--R   [[ci= w p,tci= 3,cj= w,tcj= 3,c= p s b,tc= 4,rc= s b,trc= 6,tF= 7,tD= 2]]
+--R
+--R
+--R          2             2             2             2
+--R   [[ci= b ,tci= 3,cj= s b,tcj= 6,c= s b,tc= 6,rc= s ,trc= 5,tF= 6,tD= 2]]
+--R
+--R
+--R          2              2            2
+--R   [[ci= s b,tci= 6,cj= s ,tcj= 5,c= s ,tc= 7,rc= 0,trc= 0,tF= 6,tD= 1]]
+--R
+--R
+--R          3             2            2
+--R   [[ci= s ,tci= 7,cj= s ,tcj= 5,c= s b,tc= 6,rc= s b,trc= 4,tF= 7,tD= 2]]
+--R
+--R
+--R          2
+--R   [[ci= b ,tci= 3,cj= s b,tcj= 4,c= s b,tc= 4,rc= s,trc= 3,tF= 6,tD= 2]]
+--R
+--R
+--R   [[ci= s b,tci= 4,cj= s,tcj= 3,c= s,tc= 4,rc= 0,trc= 0,tF= 6,tD= 1]]
+--R
+--R
+--R          2
+--R   [[ci= s ,tci= 5,cj= s,tcj= 3,c= s b,tc= 4,rc= 0,trc= 0,tF= 6,tD= 0]]
+--R
+--R
+--R     There are
+--R
+--R   6
+--R
+--R     Groebner Basis Polynomials.
+--R
+--R
+--R       THE GROEBNER BASIS POLYNOMIALS
+--R
+--R   (10)
+--R         19      1323      31     153      49     1143      37      27
+--R   [w + --- b + -----, p - -- b - ---, z + -- b + ----, t - -- b + ---,
+--R        120     20000      18     200      36     2000      15     250
+--R        5      9    2   33      2673
+--R    s - - b - ---, b  + -- b + -----]
+--R        2     200       50     10000
+--RType: List(DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer)))
+--E 10
+
+--S 11 of 12
+groebner(sn7,"redcrit")
+--R 
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R       5     61     77      7
+--R   z + - t - -- s + -- b + --
+--R       8     45     24     10
+--R
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R         66        603     278  2   11       672     2277     415881
+--R   t s - -- t b + ---- t - --- s  + -- s b - --- s - ---- b - ------
+--R         29       1450     435      29       725     7250     725000
+--R
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R       100  2   160       104      37      79
+--R   t + --- s  - --- s b - --- s - --- b - ---
+--R       189       63        63     105     125
+--R
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R    3   1026  2    5424  2   2529       1326807     12717      660717
+--R   s  - ---- s b - ---- s  - ---- s b - ------- s + ----- b + -------
+--R         145       3625       725        362500      6250     3625000
+--R
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R      2     91248294  2   6550614        7087292937     20020838931
+--R     s b + --------- s  - ------- s b + ----------- s - ----------- b
+--R           128176525      5127061       12817652500     12817652500
+--R   + 
+--R       37595502243
+--R     - -----------
+--R       51270610000
+--R
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R      2   4746183626079988       1015195815329760     30723564870033201
+--R     s  - ---------------- s b - ---------------- s - ----------------- b
+--R           987357073521193        987357073521193     24683926838029825
+--R   + 
+--R       3696123458901625353
+--R     - -------------------
+--R       2468392683802982500
+--R
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R   0
+--R
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R           16827373608076633182513471     1262793163581645698534964
+--R     s b + -------------------------- s - ------------------------- b
+--R           23063714246644859914108300     5765928561661214978527075
+--R   + 
+--R      91594345205981119652436033
+--R     ---------------------------
+--R     144148214041530374463176875
+--R
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R       5      9
+--R   s - - b - ---
+--R       2     200
+--R
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R   0
+--R
+--R
+--R
+--R
+--R    reduced Critpair - Polynom :
+--R
+--R
+--R   0
+--R
+--R
+--R       THE GROEBNER BASIS POLYNOMIALS
+--R
+--R   (11)
+--R         19      1323      31     153      49     1143      37      27
+--R   [w + --- b + -----, p - -- b - ---, z + -- b + ----, t - -- b + ---,
+--R        120     20000      18     200      36     2000      15     250
+--R        5      9    2   33      2673
+--R    s - - b - ---, b  + -- b + -----]
+--R        2     200       50     10000
+--RType: List(DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer)))
+--E 11
+
+--S 12 of 12
+groebner(sn7)
+--R 
+--R
+--R   (12)
+--R         19      1323      31     153      49     1143      37      27
+--R   [w + --- b + -----, p - -- b - ---, z + -- b + ----, t - -- b + ---,
+--R        120     20000      18     200      36     2000      15     250
+--R        5      9    2   33      2673
+--R    s - - b - ---, b  + -- b + -----]
+--R        2     200       50     10000
+--RType: List(DistributedMultivariatePolynomial([w,p,z,t,s,b],Fraction(Integer)))
+--E 12
+ 
+)spool 
+)lisp (bye)
+ 
+\end{chunk}
+\eject
+\begin{thebibliography}{99}
+\bibitem{1} nothing
+\end{thebibliography}
+\end{document}
